{ KOL MCK } // Do not remove this line!
{$DEFINE KOL_MCK}
unit MainLinesDiff;

interface

{$IFDEF KOL_MCK}
uses Windows, Messages, ShellAPI, KOL {$IFNDEF KOL_MCK}, mirror, Classes,
  mckCtrls, Controls, Graphics, mckObjs {$ENDIF};
{$ELSE}
{$I uses.inc}
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs;
{$ENDIF}

const
  RegKey = 'Software\Bonanzas\LinesDiff\';
  MaxCache = 100;
  LookDistance = 100;
  WM_USER_SYNC_SCROLL1 = WM_USER + 111;
  WM_USER_SYNC_SCROLL2 = WM_USER + 211;

type
  TColorArea = ( caEqText, caEqBack, caEqSelText, caEqSelBack,
                 caDiffText, caDiffBack, caDiffSelText, caDiffSelBack,
                 caNone, caNoneSel );

  {$IFDEF KOL_MCK}
  {$I MCKfakeClasses.inc}
  {$IFDEF KOLCLASSES} TForm1 = class; PForm1 = TForm1; {$ELSE OBJECTS} PForm1 = ^TForm1; {$ENDIF CLASSES/OBJECTS}
  {$IFDEF KOLCLASSES}{$I TForm1.inc}{$ELSE} TForm1 = object(TObj) {$ENDIF}
    Form: PControl;
  {$ELSE not_KOL_MCK}
  TForm1 = class(TForm)
  {$ENDIF KOL_MCK}
    Panel1: TKOLPanel;
    KOLProject1: TKOLProject;
    KOLForm1: TKOLForm;
    CB1: TKOLComboBox;
    Label1: TKOLLabel;
    Bt1: TKOLButton;
    OD1: TKOLOpenSaveDialog;
    CB2: TKOLComboBox;
    Bt2: TKOLButton;
    B3: TKOLButton;
    ckCase: TKOLCheckBox;
    ckSpaces: TKOLCheckBox;
    ckTabs: TKOLCheckBox;
    Panel2: TKOLPanel;
    Toolbar1: TKOLToolbar;
    LV1: TKOLListView;
    LV2: TKOLListView;
    Button1: TKOLButton;
    Thread1: TKOLThread;
    Panel3: TKOLPanel;
    pStat1: TKOLPanel;
    pStat2: TKOLPanel;
    PopupMenu1: TKOLPopupMenu;
    KOLApplet1: TKOLApplet;
    procedure Bt1Click(Sender: PObj);
    procedure Bt2Click(Sender: PObj);
    procedure KOLForm1Close(Sender: PObj; var Accept: Boolean);
    procedure KOLForm1FormCreate(Sender: PObj);
    procedure CB1Change(Sender: PObj);
    procedure B3Click(Sender: PObj);
    procedure Panel2Resize(Sender: PObj);
    procedure KOLForm1Show(Sender: PObj);
    procedure KOLForm1Destroy(Sender: PObj);
    procedure LV1LVData(Sender: PControl; Idx, SubItem: Integer;
      var Txt: String; var ImgIdx: Integer; var State: Cardinal;
      var Store: Boolean);
    procedure Button1Click(Sender: PObj);
    procedure LV1Scroll(Sender: PControl; Bar: TScrollerBar; ScrollCmd,
      ThumbPos: Cardinal);
    procedure LV2Scroll(Sender: PControl; Bar: TScrollerBar; ScrollCmd,
      ThumbPos: Cardinal);
    procedure Toolbar1TBCompAnotherClick(Sender: PControl; BtnID: Integer);
    procedure Toolbar1TBNextClick(Sender: PControl; BtnID: Integer);
    procedure Toolbar1TBPrevClick(Sender: PControl; BtnID: Integer);
    function LV1LVCustomDraw(Sender: PControl; DC: HDC; Stage: Cardinal;
      ItemIdx, SubItemIdx: Integer; const Rect: TRect;
      ItemState: TDrawState; var TextColor, BackColor: Integer): Cardinal;
    function Thread1Execute(Sender: PThread): Integer;
    procedure LV1KeyDown(Sender: PControl; var Key: Integer;
      Shift: Cardinal);
    procedure PopupMenu1pmCopyMenu(Sender: PMenu; Item: Integer);
    procedure PopupMenu1pmFindMenu(Sender: PMenu; Item: Integer);
    procedure LV1MouseDown(Sender: PControl; var Mouse: TMouseEventData);
    procedure PopupMenu1Popup(Sender: PObj);
    procedure PopupMenu1pmNextMenu(Sender: PMenu; Item: Integer);
    procedure LV1Enter(Sender: PObj);
    procedure LV2Enter(Sender: PObj);
    function KOLApplet1Message(var Msg: tagMSG;
      var Rslt: Integer): Boolean;
    procedure Toolbar1TBFontClick(Sender: PControl; BtnID: Integer);
    procedure PopupMenu1N2Menu(Sender: PMenu; Item: Integer);
    procedure PopupMenu1N3Menu(Sender: PMenu; Item: Integer);
    procedure PopupMenu1pmGoStartSelMenu(Sender: PMenu; Item: Integer);
    procedure PopupMenu1pmGoEndSelMenu(Sender: PMenu; Item: Integer);
    procedure Toolbar1TBSyncLRClick(Sender: PControl; BtnID: Integer);
    procedure Toolbar1TBSyncRLClick(Sender: PControl; BtnID: Integer);
    procedure LV1EraseBkgnd(Sender: PControl; DC: HDC);
    procedure LV1LVStateChange(Sender: PControl; IdxFrom, IdxTo: Integer;
      OldState, NewState: Cardinal);
  private
    { Private declarations }
    procedure Collect( CB: PControl; InsertPos: Integer; const Str: String );
    procedure EnableB3;
    procedure SaveRegistry;
    procedure LoadRegistry;
    //procedure CompareUsingStrings;
    //function Eq( L1, L2: PStrList ): Boolean;
    procedure StartCompare;
  public
    { Public declarations }
    Colors: array[ TColorArea ] of TColor;
    F1, F2: PStream;
    L1, L2: PList;
    M1, M2: PList;
    Cache1, Cache2, Ch1, Ch2: PStrListEx;
    Compare_Case, Compare_Spaces, Compare_Tabs: Boolean;
    SynchronizeScroll: Boolean;
    Count1, Count2: Integer;
    WantClose: Boolean;
    WantStop: Boolean;
    CurDiffLine: Integer;
    DiffList: PList;
    StartSelLine, CountSelLines: Integer; //  
    LastLV: Integer;
    function Eof1: Boolean;
    function Eof2: Boolean;
    function Eof( F: PStream; L: PList ): Boolean;
    procedure Provide( F: PStream; L: PList; Idx: Integer );
    function GetStr( N: Integer; F: PStream; L: PList; Cache: PStrListEx ): String;
    function GetCC( N: Integer; F: PStream; L: PList; Cache: PStrListEx ): DWORD;
    function IsNullStr( N: Integer; L: PList ): Boolean;
    function Eq( S1, S2: String ): Boolean;
    function CompareLinesFast( S1, S2: PChar ): Boolean;
    function EqLines( I1, I2: Integer ): Boolean;
    function EqTh( I1, I2: Integer ): Boolean;
    procedure DoSynchronizeScroll( Sender: PControl; Bar: TScrollerBar; ThumbPos: DWORD );
  public
    CritSec: _RTL_Critical_section;
    TstBmp: PBitmap;
    procedure IncreaseLVCounts;
    procedure InsertDummies( L: PList; Before, N: Integer );
    procedure ClearCaches;
    procedure CountLineNumbers( L: Integer );
    function GetLineNum( N: Integer; L: PList ): Integer;
    procedure FindPattern( F: String );
    procedure AdjustHorzScrolls;
  public
    ContLeftFrom, ContRightFrom: Integer;
    WantReSynchronize: Boolean;
    procedure ChkSynchronizations;
    procedure InitUpCase;
  end;

var
  Form1 {$IFDEF KOL_MCK} : PForm1 {$ELSE} : TForm1 {$ENDIF} ;

{$IFDEF KOL_MCK}
procedure NewForm1( var Result: PForm1; AParent: PControl );
{$ENDIF}

implementation

uses FindUnit, SelFontUnit;

{$IFNDEF KOL_MCK} {$R *.DFM} {$ENDIF}

{$IFDEF KOL_MCK}
{$I MainLinesDiff_1.inc}
{$ENDIF}

var UpCase: array[ Char ] of Char;

type
  TControl1 = object( TControl )
  end;
  PControl1 = ^TControl1;

procedure TForm1.Bt1Click(Sender: PObj);
begin
  if OD1.Execute then
  begin
    CB1.Caption := OD1.Filename;
    Collect( CB1, 0, OD1.Filename );
    Collect( CB2, 1, OD1.Filename );
  end;
end;

procedure TForm1.Bt2Click(Sender: PObj);
begin
  if OD1.Execute then
  begin
    CB2.Caption := OD1.Filename;
    Collect( CB2, 0, OD1.Filename );
    Collect( CB1, 1, OD1.Filename );
  end;
end;

procedure TForm1.Collect( CB: PControl; InsertPos: Integer; const Str: String );
var I: Integer;
begin
  if Trim( Str ) = '' then Exit;
  I := CB.Perform( CB_FINDSTRINGEXACT, -1, Integer( PChar( Str ) ) );
  if I = InsertPos then Exit;
  if I >= 0 then
    CB.Delete( I );
  I := CB.Insert( InsertPos, Str );
  if InsertPos = 0 then
    CB.CurIndex := I;
  EnableB3;
end;

procedure TForm1.EnableB3;
begin
  B3.Enabled := FileExists( CB1.Caption ) and FileExists( CB2.Caption );
end;

procedure TForm1.KOLForm1Close(Sender: PObj; var Accept: Boolean);
begin
  WantClose := TRUE;
  WantStop := TRUE;
  SaveRegistry;
  Sleep( 100 );
end;

procedure TForm1.LoadRegistry;
var R: THandle;
    I: Integer;
    S, S2: String;
    D: TRect;
    CA: TColorArea;
begin
  R := RegKeyOpenRead( HKEY_CURRENT_USER, RegKey );
  if RegKeyValExists( R, 'Left' ) then
  begin
    Form.Left := RegKeyGetDw( R, 'Left' );
    Form.Top := RegKeyGetDw( R, 'Top' );
    D := GetDesktopRect;
    I := RegKeyGetDw( R, 'Width' );
    if I > D.right - D.Left then
      I := D.right - D.Left;
    if Form.Left + I > D.right then
      I := D.Right - Form.Left;
    Form.Width := I;
    I := RegKeyGetDw( R, 'Height' );
    if I > D.Bottom - D.Top then
      I := D.Bottom - D.Top;
    if Form.Top + I > D.Bottom then
      I := D.Bottom - Form.Top;
    Form.Height := I;
  end;
  if RegKeyValExists( R, 'FontName' ) then
  begin
    LV1.Font.FontName := RegKeyGetStr( R, 'FontName' );
    LV1.Font.FontHeight := RegKeyGetDw( R, 'FontHeight' );
    if RegKeyGetDw( R, 'FontBold' ) <> 0 then
      LV1.Font.FontStyle := [ fsBold ];
    LV2.Font.FontName := RegKeyGetStr( R, 'FontName' );
    LV2.Font.FontHeight := RegKeyGetDw( R, 'FontHeight' );
    if RegKeyGetDw( R, 'FontBold' ) <> 0 then
      LV2.Font.FontStyle := [ fsBold ];
    for CA := Low( CA ) to High( CA ) do
      Colors[ CA ] := RegKeyGetDw( R, 'Color' + Int2Str( Ord( CA ) ) );
  end;
  for I := 1 to 20 do
  begin
    S := RegKeyGetStr( R, 'S' + Int2Str( I ) );
    if Trim( S ) <> '' then
    begin
      if CB1.Perform( CB_FINDSTRINGEXACT, -1, Integer( PChar( S ) ) ) < 0 then
        CB1.Add( S );
      if CB2.Perform( CB_FINDSTRINGEXACT, -1, Integer( PChar( S ) ) ) < 0 then
        CB2.Add( S );
    end;
  end;
  S := RegKeyGetStr( R, 'CB1' );
  S2 := RegKeyGetStr( R, 'CB2' );
  Collect( CB1, 0, S );
  Collect( CB2, 0, S2 );
  Collect( CB1, 1, S2 );
  Collect( CB2, 1, S );
  ckCase.Checked := RegKeyGetDw( R, 'Case' ) <> 0;
  ckSpaces.Checked := RegKeyGetDw( R, 'Spaces' ) <> 0;
  ckTabs.Checked := RegKeyGetDw( R, 'Tabs' ) <> 0;
  RegKeyClose( R );
end;

procedure TForm1.SaveRegistry;
var R: THandle;
    I, N: Integer;
    S: String;
    CA: TColorArea;
begin
  R := RegKeyOpenCreate( HKEY_CURRENT_USER, RegKey );
  RegKeySetStr( R, 'CB1', CB1.Caption );
  RegKeySetStr( R, 'CB2', CB2.Caption );
  N := 0;
  for I := 0 to Min( CB1.Count-1, 19 ) do
  begin
    S := CB1.Items[ I ];
    if (S <> CB1.Caption) and (S <> CB2.Caption)  then
    begin
      Inc( N );
      RegKeySetStr( R, 'S' + Int2Str( N ), S );
    end;
  end;
  if N < 19 then
  begin
    Inc( N );
    RegKeyDeleteValue( R, 'S' + Int2Str( N ) );
  end;
  RegKeySetDw( R, 'Case', Integer( ckCase.Checked ) );
  RegKeySetDw( R, 'Spaces', Integer( ckSpaces.Checked ) );
  RegKeySetDw( R, 'Tabs', Integer( ckTabs.Checked ) );
  RegKeySetDw( R, 'Left', Form.Left );
  RegKeySetDw( R, 'Top', Form.Top );
  RegKeySetDw( R, 'Width', Form.Width );
  RegKeySetDw( R, 'Height', Form.Height );
  RegKeySetStr( R, 'FontName', LV1.Font.FontName );
  RegKeySetDw( R, 'FontHeight', LV1.Font.FontHeight );
  RegKeySetDw( R, 'FontBold', Integer( fsBold in LV1.Font.FontStyle ) );

  for CA := Low( CA ) to High( CA ) do
    RegKeySetDw( R, 'Color' + Int2Str( Ord( CA ) ), Colors[ CA ] );

  RegKeyClose( R );
end;

procedure TForm1.KOLForm1FormCreate(Sender: PObj);
var S: String;
begin
  InitUpCase;
  Toolbar1.TBButtonEnabled[ TBSyncLR ] := FALSE;
  Toolbar1.TBButtonEnabled[ TBSyncRL ] := FALSE;

  Colors[ caEqText ] := clWindowText;
  Colors[ caEqBack ] := clWindow;
  Colors[ caEqSelText ] := clHighlightText;
  Colors[ caEqSelBack ] := clHighlight;
  Colors[ caDiffText ] := clRed;
  Colors[ caDiffBack ] := clWindow;
  Colors[ caDiffSelText ] := clYellow;
  Colors[ caDiffSelBack ] := clHighlight;
  Colors[ caNone ] := clYellow;
  Colors[ caNoneSel ] := clOlive;

  S := CB1.Caption;
  if S = '' then S := CB2.Caption;
  if S <> '' then
    OD1.InitialDir := ExtractFilePath( S );
  L1 := NewList;
  L1.AddBy := 100000;
  L2 := NewList;
  L2.AddBy := L1.AddBy;
  M1 := NewList;
  M1.AddBy := L1.AddBy;
  M2 := NewList;
  M2.AddBy := L1.AddBy;
  DiffList := NewList;
  DiffList.AddBy := 10000;
  L1.Tag := DWORD( M1 );
  L2.Tag := DWORD( M2 );
  Cache1 := NewStrListEx;
  Cache2 := NewStrListEx;
  Ch1 := NewStrListEx;
  Ch2 := NewStrListEx;
  LoadRegistry;
  InitializeCriticalSection( CritSec );
end;

procedure TForm1.CB1Change(Sender: PObj);
begin
  EnableB3;
end;

procedure TForm1.B3Click(Sender: PObj);
{var L1, L2: PStrList;
    I: Integer;
    S1, S2: String;}
begin
  //Memo1.Clear;
  Count1 := 0;
  Count2 := 0;
  LV1.LVCount := 0;
  LV2.LVCount := 0;
  pStat1.Text := '';
  pStat2.Text := '';
  L1.Clear;
  L2.Clear;
  M1.Clear;
  M2.Clear;
  Cache1.Clear;
  Cache2.Clear;

  Collect( CB1, 0, CB1.Caption );
  Collect( CB2, 0, CB2.Caption );
  Collect( CB1, 1, CB2.Caption );
  Collect( CB2, 1, CB1.Caption );

  //Form.ActiveControl := LV1;
  LV1.Focused := TRUE;

  StartCompare;

end;

procedure TForm1.Panel2Resize(Sender: PObj);
begin
  LV1.Width := ( Panel2.Width - Panel2.Border * 3 ) div 2;
  {LV1.LVColWidth[ 0 ] := LV1.ClientWidth;
  LV2.LVColWidth[ 0 ] := LV2.ClientWidth;}
  AdjustHorzScrolls;
  pStat1.Width := LV1.Width;
end;

procedure TForm1.KOLForm1Show(Sender: PObj);
begin
  Panel2Resize( nil );
end;

procedure TForm1.StartCompare;
begin
  LV1.LVCount := 0;
  LV2.LVCount := 0;
  Panel1.Visible := FALSE;
  F1 := NewFileStream( CB1.Text, ofOpenRead or ofOpenExisting or ofShareDenyNone );
  F2 := NewFileStream( CB2.Text, ofOpenRead or ofOpenExisting or ofShareDenyNone );
  Cache1.Clear;
  Cache2.Clear;
  L1.Clear;
  L2.Clear;
  M1.Clear;
  M2.Clear;
  Compare_Case   := ckCase.Checked;
  Compare_Spaces := ckSpaces.Checked;
  Compare_Tabs   := ckTabs.Checked;
  WantClose := FALSE;
  WantStop := FALSE;
  SynchronizeScroll := TRUE;
  DiffList.Clear;
  CurDiffLine := -1;
  StartSelLine := -1;
  CountSelLines := 0;
  WantReSynchronize := FALSE;
  Thread1.Resume;
end;

procedure TForm1.KOLForm1Destroy(Sender: PObj);
begin
  TstBmp.Free;
  F1.Free;
  F2.Free;
  L1.Free;
  L2.Free;
  M1.Free;
  M2.Free;
  Cache1.Free;
  Cache2.Free;
  Ch1.Free;
  Ch2.Free;
  DiffList.Free;
  DeleteCriticalSection( CritSec );
end;

function TForm1.Eof1: Boolean;
begin
  EnterCriticalSection( CritSec );
  TRY
    Result := (L1.Count > 0) and (DWORD( L1.Items[ L1.Count-1 ] ) >= F1.Size);
  FINALLY
    LeaveCriticalSection( CritSec );
  END;
end;

function TForm1.Eof2: Boolean;
begin
  EnterCriticalSection( CritSec );
  TRY
    Result := (L2.Count > 0) and (DWORD( L2.Items[ L2.Count-1 ] ) >= F2.Size);
  FINALLY
    LeaveCriticalSection( CritSec );
  END;
end;

procedure TForm1.Provide(F: PStream; L: PList; Idx: Integer);
const BufSz = 10000;
var Buf: PChar;
    P, Len, LineLen: DWORD;
    Cur: PChar;
    AddedLines: Integer;
    StopAfterLine: Boolean;
label Read_further;
begin
  if F = nil then Exit;
  StopAfterLine := FALSE;
  GetMem( Buf, BufSz );
  EnterCriticalSection( CritSec );
  TRY

    P := 0;
    if L.Count > 0 then
      P := DWORD( L.Items[ L.Count-1 ] )
    else
    begin
      L.Add( nil );
      PList( L.Tag ).Add( nil );
    end;
    while TRUE do
    begin
      if (L.Count > 0) and (DWORD( L.Items[ L.Count-1 ] ) >= F.Size) then Exit;
      if L.Count > Idx + 1 then Exit;
      F.Position := P;
      AddedLines := 0;
      Read_further:
        Len := F.Read( Buf^, BufSz );
        if Len = 0 then
        begin
          L.Add( Pointer( F.Size ) );
          PList( L.Tag ).Add( nil );
          Exit;
        end;
        Cur := Buf;
        LineLen := 0;
        while Len > 0 do
        begin
          Dec( Len );
          Inc( Cur );
          Inc( LineLen );
          if (Len = 0) and (AddedLines = 0) then
          begin
            StopAfterLine := TRUE;
            if Cur[ -1 ] = #13 then
            begin
              Buf[ 0 ] := #13;
              Len := 1 + F.Read( Buf[ 1 ], BufSz-1 );
              if Len = 1 then
              begin
                L.Add( Pointer( F.Size ) );
                PList( L.Tag ).Add( nil );
                Exit;
              end;
              Cur := Buf;
            end
              else
            goto Read_further;
          end;
          if Cur[ -1 ] in [ #13, #10 ] then
          begin
            if (Len > 0) and (Cur[ -1 ] = #13) and (Cur[ 0 ] = #10) then
            begin
              Dec( Len );
              Inc( Cur );
              Inc( LineLen );
            end;
            Inc( AddedLines );
            P := P + LineLen;
            L.Add( Pointer( P ) );
            PList( L.Tag ).Add( nil );
            LineLen := 0;
            if StopAfterLine then Exit;
          end;
        end;
    end;

  FINALLY
    FreeMem( Buf );
    LeaveCriticalSection( CritSec );
  END;
end;

function TForm1.GetStr( N: Integer; F: PStream; L: PList; Cache: PStrListEx): String;
var I, J: Integer;
    Len: DWORD;
begin
  Provide( F, L, N );
  EnterCriticalSection( CritSec );
  TRY

  Result := '';
  if L.Count-1 < N then Exit;
  I := Cache.IndexOfObj( Pointer( N ) );
  if I < 0 then
  begin
    if Cache.Count > MaxCache then
      Cache.Delete( Cache.Count-1 );
    if N >= L.Count-1 then Exit;
    Len := DWORD( L.Items[ N+1 ] ) - DWORD( L.Items[ N ] );
    if Len = 0 then Exit;
    F.Position := DWORD( L.Items[ N ] );
    SetLength( Result, Len );
    F.Read( Result[ 1 ], Len );
    J := pos( #13, Result );
    if J <= 0 then J := pos( #10, Result );
    if J <= 0 then J := pos( #0, Result );
    if (J > 0) and (J <= Length( Result )) then
      Delete( Result, J, MaxInt );
    Cache.InsertObject( 0, Result, N );
  end
    else
  begin
    Result := Cache.Items[ I ];
    if I <> 0 then
    begin
      Cache.Delete( I );
      Cache.InsertObject( 0, Result, N );
    end;
  end;
  FINALLY
    LeaveCriticalSection( CritSec );
  END;
end;

function TForm1.Eof(F: PStream; L: PList): Boolean;
begin
  EnterCriticalSection( CritSec );
  TRY
    Result := (L.Count > 0) and (DWORD( L.Items[ L.Count-1 ] ) >= F.Size);
  FINALLY
    LeaveCriticalSection( CritSec );
  END;
end;

procedure TForm1.LV1LVData(Sender: PControl; Idx, SubItem: Integer;
  var Txt: String; var ImgIdx: Integer; var State: Cardinal;
  var Store: Boolean);
var I, NxTabPos: Integer;
begin
    if Sender = LV1 then Txt := GetStr( Idx, F1, L1, Cache1 )
                    else Txt := GetStr( Idx, F2, L2, Cache2 );
    while pos( #9, Txt ) > 0 do
    begin
      I := pos( #9, Txt );
      NxTabPos := (I - 1 + 8) and not 7;
      StrReplace( Txt, #9, StrRepeat( ' ', NxTabPos - I + 1 ) );
    end;
end;

function TForm1.Eq(S1, S2: String): Boolean;
begin
  if not Compare_Tabs then
  begin
    while StrReplace( S1, #9, ' ' ) do;
    while StrReplace( S2, #9, ' ' ) do;
  end;
  if not Compare_Spaces then
  begin
    while StrReplace( S1, '  ', ' ' ) do;
    while StrReplace( S2, '  ', ' ' ) do;
    S1 := Trim( S1 );
    S2 := Trim( S2 );
  end;
  if not Compare_Case then
  begin
    S1 := AnsiUpperCase( S1 );
    S2 := AnsiUpperCase( S2 );
  end;
  Result := S1 = S2;
end;

procedure TForm1.Button1Click(Sender: PObj);
begin
  ShowMessage( 'DiffLines v1.3 (C) by Vladimir Kladov 2003'#13#10#13#10 +
                'Allows to compare _huge_ text files line-by-line.'#13#10#13#10 +
                'http://bonanzas.rinet.ru' );
end;

procedure TForm1.LV1Scroll(Sender: PControl; Bar: TScrollerBar; ScrollCmd,
  ThumbPos: Cardinal);
var M: TMsg;
begin
  if not PeekMessage( M, Form.Handle, WM_USER_SYNC_SCROLL1, WM_USER_SYNC_SCROLL1,
        pm_noremove ) then
    PostMessage( Form.Handle, WM_USER_SYNC_SCROLL1, Integer( Bar ), ThumbPos );
  //DoSynchronizeScroll( Sender, Bar, ThumbPos );
end;

procedure TForm1.LV2Scroll(Sender: PControl; Bar: TScrollerBar; ScrollCmd,
  ThumbPos: Cardinal);
var M: TMsg;
begin
  if not PeekMessage( M, Form.Handle, WM_USER_SYNC_SCROLL2, WM_USER_SYNC_SCROLL2,
        pm_noremove ) then
    PostMessage( Form.Handle, WM_USER_SYNC_SCROLL2, Integer( Bar ), ThumbPos );
  //DoSynchronizeScroll( Sender, Bar, ThumbPos );
end;

procedure TForm1.DoSynchronizeScroll(Sender: PControl; Bar: TScrollerBar;
  ThumbPos: DWORD);
var I, I2: Integer;
    OtherLV: PControl;
begin
  if not SynchronizeScroll then Exit;
  if Sender = LV1 then OtherLV := LV2
                  else OtherLV := LV1;
  if Bar = sbVertical then
  begin
    I := Sender.LVTopItem;
    I2 := OtherLV.LVTopItem;
    if I2 <> I then
    begin
      if I2 > I then
        OtherLV.LVMakeVisible( I, FALSE )
      else
      begin
        OtherLV.LVMakeVisible( I + OtherLV.LVPerPage - 1, FALSE );
        OtherLV.LVMakeVisible( I, FALSE );
      end;
    end;
  end;

  AdjustHorzScrolls;
  //SetScrollPos( LV2.Handle, Integer( Bar ), ThumbPos, TRUE );
end;

procedure TForm1.Toolbar1TBCompAnotherClick(Sender: PControl; BtnID: Integer);
begin
  WantStop := TRUE;
  Panel1.Visible := TRUE;
  CB1.Focused := TRUE;
end;

procedure TForm1.Toolbar1TBNextClick(Sender: PControl; BtnID: Integer);
  procedure GoLine( I: Integer );
  begin
      CurDiffLine := I;
      StartSelLine := I;
      Dec( I, LV1.LVPerPage div 2 );
      if I < 0 then I := 0;
      LV1.LVCurItem := -1;
      LV1.LVCurItem := I;
      LV2.LVCurItem := -1;
      LV2.LVCurItem := I;
      LV1.LVMakeVisible( I + LV1.LVPerPage - 1, FALSE );
      LV2.LVMakeVisible( I + LV2.LVPerPage - 1, FALSE );
      LV1.LVMakeVisible( I, FALSE );
      LV2.LVMakeVisible( I, FALSE );
      I := StartSelLine;
      while I < min( LV1.LVCount, LV2.LVCount ) do
      begin
        Inc( I );
        //S1 := GetStr( I, F1, L1, Cache1 );
        //S2 := GetStr( I, F2, L2, Cache2 );
        //if Eq( S1, S2 ) then
        if EqLines( I, I ) then
        begin
          CountSelLines := I - StartSelLine;
          break;
        end;
      end;
      CountLineNumbers( StartSelLine );
      AdjustHorzScrolls;
      LV1.Invalidate;
      LV2.Invalidate;
  end;

var I: Integer;
    //S1, S2: String;
    SkippingDiff: Boolean;
    WasInList: Boolean;
begin
  I := DiffList.IndexOf( Pointer( CurDiffLine ) );
  WasInList := (I >= 0) or (CurDiffLine = -1) and (DiffList.Count=0);
  if (I >= 0) and (I < DiffList.Count-1) then
  begin
    GoLine( DWORD( DiffList.Items[ I+1 ] ) );
    Exit;
  end;
  I := CurDiffLine;
  SkippingDiff := CurDiffLine >= 0;
  while I < min( LV1.LVCount, LV2.LVCount ) do
  begin
    Inc( I );
    if SkippingDiff then
    begin
      if EqLines( I, I ) then
        SkippingDiff := FALSE;
    end
      else
    if not EqLines( I, I ) then
    begin
      GoLine( I );
      if WasInList then
        DiffList.Add( Pointer( I ) );
      Exit;
    end;
  end;
end;

procedure TForm1.Toolbar1TBPrevClick(Sender: PControl; BtnID: Integer);
  procedure GoLine( I: Integer );
  //var S1, S2: String;
  begin
      CurDiffLine := I;
      Dec( I, LV1.LVPerPage div 2 );
      if I < 0 then I := 0;
      LV1.LVCurItem := -1;
      LV1.LVCurItem := I;
      LV2.LVCurItem := -1;
      LV2.LVCurItem := I;
      LV1.LVMakeVisible( I + LV1.LVPerPage - 1, FALSE );
      LV2.LVMakeVisible( I + LV2.LVPerPage - 1, FALSE );
      LV1.LVMakeVisible( I, FALSE );
      LV2.LVMakeVisible( I, FALSE );
      I := CurDiffLine;
      StartSelLine := I;
      while I < Min( LV1.LVCount, LV2.LVCount ) - 1 do
      begin
        Inc( I );
        //S1 := GetStr( I, F1, L1, Cache1 );
        //S2 := GetStr( I, F2, L2, Cache2 );
        //if Eq( S1, S2 ) then
        if EqLines( I, I ) then
        begin
          CountSelLines := I - StartSelLine;
          break;
        end;
      end;
      CountLineNumbers( StartSelLine );
      AdjustHorzScrolls;
      LV1.Invalidate;
      LV2.Invalidate;
  end;
var I: Integer;
    //S1, S2: String;
    SkippingDiff: Boolean;
begin
  I := DiffList.IndexOf( Pointer( CurDiffLine ) );
  if I >= 0 then
  begin
    if I = 0 then Exit;
    GoLine( DWORD( DiffList.Items[ I-1 ] ) );
    Exit;
  end;
  I := CurDiffLine;
  SkippingDiff := FALSE;
  while I > 0 do
  begin
    Dec( I );
    //S1 := GetStr( I, F1, L1, Cache1 );
    //S2 := GetStr( I, F2, L2, Cache2 );
    if SkippingDiff then
    begin
      //if Eq( S1, S2 ) then
      if EqLines( I, I ) then
      begin
        GoLine( I + 1 );
        Exit;
      end;
    end
      else
    //if not Eq( S1, S2 ) then
    if not EqLines( I, I ) then
    begin
      SkippingDiff := TRUE;
      if I = 0 then
      begin
        GoLine( I );
        Exit;
      end;
    end;
  end;
end;

function TForm1.LV1LVCustomDraw(Sender: PControl; DC: HDC; Stage: Cardinal;
  ItemIdx, SubItemIdx: Integer; const Rect: TRect; ItemState: TDrawState;
  var TextColor, BackColor: Integer): Cardinal;
var
    Txt: String;
    R: TRect;
    Sel: Boolean;

    procedure ProvideColors;
    begin
      if (ItemIdx >= StartSelLine) and (ItemIdx < StartSelLine + CountSelLines) then
      begin
        Sel := TRUE;
        Sender.Canvas.Brush.Color := Colors[ caEqSelBack ];
        Sender.Canvas.Font.Color := Colors[ caEqSelText ];
      end
        else
      begin
        Sender.Canvas.Brush.Color := Colors[ caEqBack ];
        Sender.Canvas.Font.Color := Colors[ caEqText ];
      end;
      if (Sender = LV1) and (ItemIdx >= Count1) or
         (Sender = LV2) and (ItemIdx >= Count2) then
        Sender.Canvas.Font.Color := clBlue
      else
      begin
        if not EqLines( ItemIdx, ItemIdx ) then
        begin
          if Sel then
          begin
            Sender.Canvas.Font.Color := Colors[ caDiffSelText ];
            Sender.Canvas.Brush.Color := Colors[ caDiffSelBack ];
          end
          else
          begin
            Sender.Canvas.Font.Color := Colors[ caDiffText ];
            Sender.Canvas.Brush.Color := Colors[ caDiffBack ];
          end;
        end;
      end;
      Sender.Canvas.DeselectHandles;
    end;

var I, NxTabPos: Integer;
    EmptyZone: Boolean;
begin
  if LongBool(Stage and CDDS_PREPAINT) and (ItemIdx >= 0) then
  begin
    Sel := FALSE;
    Result := CDRF_SKIPDEFAULT;
    R := Sender.LVItemRect( ItemIdx, lvipBounds );
    if R.Bottom <= 0 then Exit;
    if Sender = LV1 then Txt := GetStr( ItemIdx, F1, L1, Cache1 )
                    else Txt := GetStr( ItemIdx, F2, L2, Cache2 );
    while pos( #9, Txt ) > 0 do
    begin
      I := pos( #9, Txt );
      NxTabPos := (I - 1 + 8) and not 7;
      StrReplace( Txt, #9, StrRepeat( ' ', NxTabPos - I + 1 ) );
    end;
    ProvideColors;
    if (Txt = '') then
    begin
      if Sender = LV1 then
        EmptyZone := IsNullStr( ItemIdx, L1 )
      else
        EmptyZone := IsNullStr( ItemIdx, L2 );
      if EmptyZone then
      if Sel then Sender.Canvas.Brush.Color := Colors[ caNoneSel ]
             else Sender.Canvas.Brush.Color := Colors[ caNone ];
    end;
    //Sender.Canvas.FillRect( R );
    Sender.Canvas.TextRect( R, R.Left, R.Top, Txt );

    Sender.Canvas.Brush.Color := clWindow;
    Sender.Canvas.Brush.BrushStyle := bsSolid;
    Sender.Canvas.Font.Color := clWindowText;
  end
    else
  begin
    ProvideColors;
    Result := CDRF_NOTIFYITEMDRAW;
  end;
end;

function TForm1.Thread1Execute(Sender: PThread): Integer;
var //S1, S2, S1a, S2a, S1b, S2b: String;
    I1, I2, J1, J2, K1, K2, NewCount: Integer;
    S1available, S2available, Chk1, Chk2: Boolean;
    FoundBest: Boolean;
    S1, S2: String;
begin
  while not WantClose do
  begin
    Ch1.Clear;
    Ch2.Clear;
    while not WantStop and not WantClose and
          not (Eof1 and (Count1 >= L1.Count)) and
          not (Eof2 and (Count2 >= L2.Count)) do
    begin
      if WantReSynchronize then
      begin
        WantReSynchronize := FALSE;
        I1 := ContLeftFrom;
        I2 := ContRightFrom;
        while (I1 > 0) and (I2 > 0) and EqLines( I1 - 1, I2 - 1 ) do
        begin
          Dec( I1 ); Dec( I2 );
        end;
        if I1 < I2 then
          InsertDummies( L1, I1, I2 - I1 )
        else
        if I2 < I1 then
          InsertDummies( L2, I2, I1 - I2 );
        Count1 := Max( I1, I2 );
        Count2 := Max( I1, I2 );
        Thread1.Synchronize( IncreaseLVCounts );
      end;
      FoundBest := FALSE;
      if Count1 <> Count2 then break;
      //if (Count1 >= LV1.LVCount + 50) or (Count2 >= LV2.LVCount + 50) then
      if (Count1 >= Max( LV1.LVCount + 50, LV1.LVCount + Min( 100000, LV1.LVCount div 10 ) )) or
         (Count2 >= Max( LV2.LVCount + 50, LV2.LVCount + Min( 100000, LV2.LVCount div 10 ))) then
      begin
        Thread1.Synchronize( IncreaseLVCounts );
      end;
      if EqTh( Count1, Count2 ) then
      begin
        Inc( Count1 );
        Inc( Count2 );
        continue;
      end
        else
      begin
        I1 := Count1 + 1;
        I2 := Count2 + 1;
        S1 := Trim( GetStr( Count1, F1, L1, Ch1 ) );
        S2 := Trim( GetStr( Count2, F2, L2, Ch2 ) );
        Chk1 := not StrIn( S2, [
                '', 'end;', 'end', 'begin', 'public', 'protected', 'private', 'published' ] );
        Chk2 := not StrIn( S1, [
                '', 'end;', 'end', 'begin', 'public', 'protected', 'private', 'published' ] );
        if not Chk1 and not Chk2 then
        begin
          Chk1 := S2 <> '';
          Chk2 := S1 <> '';
        end;
        while ((I1 < Count1 + LookDistance) or (I2 < Count2 + LookDistance))
                and (Chk1 or Chk2) and
                not FoundBest and not WantStop and not WantClose and
                not WantReSynchronize do
        begin
          if Chk1 then
          begin
            S1available := not( Eof1 and (I1 >= L1.Count) );
          end
            else S1available := FALSE;

          if Chk2 then
          begin
            S2available := not( Eof2 and (I2 >= L2.Count) );
          end
            else S2available := FALSE;

          if S1available //and Eq( S1a, S2 ) and
                         and EqTh( I1, Count2 ) and
             S2available //and Eq( S2a, S1 ) then
                         and EqTh( Count1, I2 ) then
          begin //     
            J1 := I1;
            J2 := I2;
            while TRUE do
            begin
              Inc( J1 );
              Inc( J2 );
              S1available := TRUE;
              K2 := -1;
              if not( Eof1 and (J1 >= L1.Count) ) and
                 not( Eof2 and (J1 - I1 + I2 >= L2.Count) ) then
              begin
                K2 := J1 - I1 + I2;
              end
              else
                S1available := FALSE;
              S2available := TRUE;
              K1 := -1;
              if not( Eof2 and (J2 >= L2.Count) ) and
                 not( Eof1 and (J2 - I2 + I1 >= L1.Count) ) then
              begin
                K1 := J2 - I2 + I1;
              end
              else
                S2available := FALSE;
              if S1available and S2available then
              begin
                if EqTh( J1, K2 ) and EqTh( K1, J2 ) then
                  continue;
                if not EqTh( J1, K2 ) then
                  S1available := FALSE;
                if not EqTh( K1, J2 ) then
                  S2available := FALSE;
              end;
              if not S1available or not S2available then
              begin
                if S2available then //   
                begin
                  FoundBest := TRUE;
                  NewCount := I2;
                  while (Count1 > 0) do
                  begin
                    if not EqTh( Count1-1, I2-1 ) then break;
                    Dec( Count1 );
                    Dec( Count2 );
                    Dec( I2 );
                  end;
                  InsertDummies( L1, Count1, I2 - Count2 );
                  Ch1.Clear;
                  Thread1.Synchronize( ClearCaches );
                  Count1 := NewCount;
                  Count2 := NewCount;
                  break;
                end
                  else
                begin //   
                  FoundBest := TRUE;
                  NewCount := I1;
                  while (Count2 > 0) do
                  begin
                    if not EqTh( I1-1, Count2-1 ) then break;
                    Dec( Count1 );
                    Dec( Count2 );
                    Dec( I1 );
                  end;
                  InsertDummies( L2, Count2, I1 - Count1 );
                  Ch2.Clear;
                  Thread1.Synchronize( ClearCaches );
                  Count2 := NewCount;
                  Count1 := NewCount;
                  break;
                end;
              end;
            end;
          end
            else
          if S1available and EqTh( I1, Count2 ) then
          begin //     
            FoundBest := TRUE;
            NewCount := I1;
            InsertDummies( L2, Count2, I1 - Count1 );
            Ch2.Clear;
            Thread1.Synchronize( ClearCaches );
            Count2 := NewCount;
            Count1 := NewCount;
            break;
          end
            else
          if S2available and //Eq( S1, S2a ) then
                             EqTh( Count1, I2 ) then
          begin //     
            FoundBest := TRUE;
            NewCount := I2;
            InsertDummies( L1, Count1, I2 - Count2 );
            Ch1.Clear;
            Thread1.Synchronize( ClearCaches );
            Count1 := NewCount;
            Count2 := NewCount;
            break;
          end
            else
          if S1available and S2available and
             EqTh( I1, I2 ) then
          begin //    
            //       ,   
            //     ,     
            // .    .
            if I1 > Count1 - 2 then
            begin
              K1 := -1;
              K2 := -1;
              for J1 := Count1+1 to Min( I1-1, Count1+1000) do
              begin
                for J2 := J1+1 to Min( I2-1, J1+1000 ) do
                begin
                  if EqTh( J1, J2 ) then
                  begin
                    K1 := J1; K2 := J2;
                    break;
                  end;
                  if K1 >= 0 then break;
                end;
              end;
              for J2 := Count2+1 to Min( I2-1, Count2+1000 ) do
              begin
                for J1 := J2+1 to Min( I1-1, J2+1000 ) do
                begin
                  if EqTh( J1, J2 ) then
                  if (K1 < 0) or (Min( J1, J2 ) < Min( K1, K2 )) then
                  begin
                    K1 := J1; K2 := J2;
                  end;
                  break;
                end;
                if K2 = J2 then break;
              end;
              if K1 >= 0 then
              begin
                FoundBest := TRUE;
                I1 := K1;
                I2 := K2;
                if I1 < I2 then //   I1      I2  
                begin
                  NewCount := I2;
                  while I1 > Count1 do
                  begin
                    if not EqTh( I1-1, I2-1 ) then break;
                    Dec( I1 );
                    Dec( I2 );
                  end;
                  InsertDummies( L1, I1, I2 - I1 );
                  Ch1.Clear;
                  Thread1.Synchronize( ClearCaches );
                  Count1 := NewCount;
                  Count2 := NewCount;
                  break;
                end
                  else //   I2     I1  
                begin
                  NewCount := I1;
                  while I2 > Count2 do
                  begin
                    if not EqTh( I1-1, I2-1 ) then break;
                    Dec( I1 );
                    Dec( I2 );
                  end;
                  InsertDummies( L2, I2, I1 - I2 );
                  Ch2.Clear;
                  Thread1.Synchronize( ClearCaches );
                  Count2 := NewCount;
                  Count1 := NewCount;
                  break;
                end;
              end;
            end;
            FoundBest := TRUE;
            Count1 := I1;
            Count2 := I2;
            break;
          end
            else
          if not S1available and not S2available then
            break;
          Inc( I1 );
          Inc( I2 );
        end;
        if not FoundBest then
        begin
          Inc( Count1 );
          Inc( Count2 );
        end;
      end;
    end;
    Thread1.Synchronize( IncreaseLVCounts );
    while not WantStop and not WantClose and
          (not (Eof1 and (Count1 >= L1.Count)) or
           not (Eof2 and (Count2 >= L2.Count)) ) do
    begin
      if not Eof1 then
        Provide( F1, L1, Count1 + 1000 );
      if not Eof2 then
        Provide( F2, L2, Count1 + 1000 );
      Count1 := L1.Count;
      Count2 := L2.Count;
      Thread1.Synchronize( IncreaseLVCounts );
    end;
    Thread1.Synchronize( IncreaseLVCounts );
    WantStop := TRUE;
    while WantStop and not WantClose do
    begin
      Sleep( 10 );
    end;
  end;
  Result := 0;
end;

procedure TForm1.IncreaseLVCounts;
var Top1, Top2: Integer;
    Cur1, Cur2: Integer;
begin
  LV1.BeginUpdate;
  LV2.BeginUpdate;
  TRY

    if LV1.LVCount < Count1 then
    begin
      Top1 := LV1.LVTopItem;
      Cur1 := LV1.LVCurItem;
        LV1.LVCount := Count1;
        LV1.LVCurItem := Cur1;
        LV1.LVMakeVisible( Top1, FALSE );
    end;
    if LV2.LVCount < Count2 then
    begin
      Top2 := LV2.LVTopItem;
      Cur2 := LV2.LVCurItem;
        LV2.LVCount := Count2;
        LV2.LVCurItem := Cur2;
        LV2.LVMakeVisible( Top2, FALSE );
    end;

  FINALLY
    LV1.EndUpdate;
    LV2.EndUpdate;
  END;
end;

procedure TForm1.InsertDummies(L: PList; Before, N: Integer);
var Val: DWORD;
begin
  EnterCriticalSection( CritSec );
  TRY
    {if Before > 0 then
      Val := DWORD( L.Items[ Before-1 ] )
    else}
      Val := DWORD( L.Items[ Before ] );
    for N := 1 to N do
    begin
      L.Insert( Before, Pointer( Val ) );
      PList( L.Tag ).Insert( Before, nil );
    end;
  FINALLY
    LeaveCriticalSection( CritSec );
  END;
end;

procedure TForm1.ClearCaches;
begin
  Cache1.Clear;
  Cache2.Clear;
end;

procedure TForm1.LV1KeyDown(Sender: PControl; var Key: Integer;
  Shift: Cardinal);
begin
  CASE Key OF
  VK_UP: begin
           LV1.Perform( WM_VSCROLL, SB_LINEUP, 0 );
           LV2.Perform( WM_VSCROLL, SB_LINEUP, 0 );
         end;
  VK_DOWN:
         begin
           LV1.Perform( WM_VSCROLL, SB_LINEDOWN, 0 );
           LV2.Perform( WM_VSCROLL, SB_LINEDOWN, 0 );
         end;
  VK_PAGE_UP:
         begin
           LV1.Perform( WM_VSCROLL, SB_PAGEUP, 0 );
           LV2.Perform( WM_VSCROLL, SB_PAGEUP, 0 );
         end;
  VK_PAGE_DOWN:
         begin
           LV1.Perform( WM_VSCROLL, SB_PAGEDOWN, 0 );
           LV2.Perform( WM_VSCROLL, SB_PAGEDOWN, 0 );
         end;
  VK_HOME:
         begin
           LV1.Perform( WM_VSCROLL, SB_TOP, 0 );
           LV2.Perform( WM_VSCROLL, SB_TOP, 0 );
         end;
  VK_END:
         begin
           LV1.Perform( WM_VSCROLL, SB_BOTTOM, 0 );
           LV2.Perform( WM_VSCROLL, SB_BOTTOM, 0 );
         end;
  VK_LEFT:
         begin
           LV1.Perform( WM_HSCROLL, SB_LINEUP, 0 );
           LV2.Perform( WM_HSCROLL, SB_LINEUP, 0 );
         end;
  VK_RIGHT:
         begin
           LV1.Perform( WM_HSCROLL, SB_LINEDOWN, 0 );
           LV2.Perform( WM_HSCROLL, SB_LINEDOWN, 0 );
         end;
  else Exit;
  END;
  Key := 0;
end;

function TForm1.GetCC(N: Integer; F: PStream; L: PList;
  Cache: PStrListEx): DWORD;
var M: PList;
    S: String;
    I: Integer;
begin
  M := Pointer( L.Tag );
  EnterCriticalSection( CritSec );
  TRY
    Result := DWORD( M.Items[ N ] );
  FINALLY
    LeaveCriticalSection( CritSec );
  END;
  if Result = 0 then
  begin
    S := GetStr( N, F, L, Cache );
    if not Compare_Tabs then
      while StrReplace( S, #9, ' ' ) do;
    if not Compare_Spaces then
    begin
      while StrReplace( S, '  ', ' ' ) do;
      S := Trim( S );
    end;
    if not Compare_Case then
      S := AnsiUpperCase( S );
    for I := 1 to Length( S ) do
      Result := (Result shl 1) or (Result shr 31) + Ord( S[ I ] );
    EnterCriticalSection( CritSec );
    TRY
      M.Items[ N ] := Pointer( Result );
    FINALLY
      LeaveCriticalSection( CritSec );
    END;
  end;
end;

function TForm1.EqLines(I1, I2: Integer): Boolean;
var S1, S2: String;
    CC1, CC2: DWORD;
    Len1, Len2: Integer;
    Buf1, Buf2: array[ 0..1023 ] of Char;
    Bf1, Bf2: PChar;
    J1, J2: Integer;
begin
  CC1 := GetCC( I1, F1, L1, Cache1 );
  CC2 := GetCC( I2, F2, L2, Cache2 );
  Result := CC1 = CC2;
  if not Result then Exit;
  EnterCriticalSection( CritSec );
  TRY
    Len1 := 0;
    if I1 < L1.Count - 1 then
      Len1 := Integer( DWORD( L1.Items[ I1+1 ] ) - DWORD( L1.Items[ I1 ] ) );
    Len2 := 0;
    if I2 < L2.Count - 1 then
      Len2 := Integer( DWORD( L2.Items[ I2+1 ] ) - DWORD( L2.Items[ I2 ] ) );
    if (Len1 = 0) and (Len2 = 0) then
    begin
      Result := TRUE;
      Exit;
    end;
    if (Len1 < High( Buf1 )) and (Len2 < High( Buf2 )) then
    begin

      Bf1 := Buf1;
      J1 := Cache1.IndexOfObj( Pointer( I1 ) );
      if J1 >= 0 then
      begin
        Cache1.Move( J1, 0 );
        Bf1 := Cache1.ItemPtrs[ 0 ];
      end
      else
      begin
        Buf1[ Len1 ] := #0;
        F1.Position := DWORD( L1.Items[ I1 ] );
        F1.Read( Buf1[ 0 ], Len1 );
      end;

      Bf2 := Buf2;
      J2 := Cache2.IndexOfObj( Pointer( I2 ) );
      if J2 >= 0 then
      begin
        Cache2.Move( J2, 0 );
        Bf2 := Cache2.ItemPtrs[ 0 ];
      end
      else
      begin
        Buf2[ Len2 ] := #0;
        F2.Position := DWORD( L2.Items[ I2 ] );
        F2.Read( Buf2[ 0 ], Len2 );
      end;

      Result := CompareLinesFast( Bf1, Bf2 );
      Exit;

    end;
  FINALLY
    LeaveCriticalSection( CritSec );
  END;
  S1 := GetStr( I1, F1, L1, Cache1 );
  S2 := GetStr( I2, F2, L2, Cache2 );
  Result := Eq( S1, S2 );
end;

function TForm1.EqTh(I1, I2: Integer): Boolean;
var S1, S2: String;
    CC1, CC2: DWORD;
    Len1, Len2: Integer;
    Buf1, Buf2: array[ 0..1023 ] of Char;
    Bf1, Bf2: PChar;
    J1, J2: Integer;
begin
  CC1 := GetCC( I1, F1, L1, Ch1 );
  CC2 := GetCC( I2, F2, L2, Ch2 );
  Result := CC1 = CC2;
  if not Result then Exit;
  EnterCriticalSection( CritSec );
  TRY
    Len1 := 0;
    if I1 < L1.Count - 1 then
      Len1 := Integer( DWORD( L1.Items[ I1+1 ] ) - DWORD( L1.Items[ I1 ] ) );
    Len2 := 0;
    if I2 < L2.Count - 1 then
      Len2 := Integer( DWORD( L2.Items[ I2+1 ] ) - DWORD( L2.Items[ I2 ] ) );
    if (Len1 = 0) and (Len2 = 0) then
    begin
      Result := TRUE;
      Exit;
    end;
    if (Len1 < High( Buf1 )) and (Len2 < High( Buf2 )) then
    begin

      Bf1 := Buf1;
      J1 := Ch1.IndexOfObj( Pointer( I1 ) );
      if J1 >= 0 then
      begin
        Ch1.Move( J1, 0 );
        Bf1 := Ch1.ItemPtrs[ 0 ];
      end
      else
      begin
        Buf1[ Len1 ] := #0;
        F1.Position := DWORD( L1.Items[ I1 ] );
        F1.Read( Buf1[ 0 ], Len1 );
      end;

      Bf2 := Buf2;
      J2 := Ch2.IndexOfObj( Pointer( I2 ) );
      if J2 >= 0 then
      begin
        Ch2.Move( J2, 0 );
        Bf2 := Ch2.ItemPtrs[ 0 ];
      end
      else
      begin
        Buf2[ Len2 ] := #0;
        F2.Position := DWORD( L2.Items[ I2 ] );
        F2.Read( Buf2[ 0 ], Len2 );
      end;

      Result := CompareLinesFast( Bf1, Bf2 );
      Exit;

    end;
  FINALLY
    LeaveCriticalSection( CritSec );
  END;
  S1 := GetStr( I1, F1, L1, Ch1 );
  S2 := GetStr( I2, F2, L2, Ch2 );
  Result := Eq( S1, S2 );
end;

procedure TForm1.CountLineNumbers(L: Integer);
var I: Integer;
    Pos: DWORD;
begin
  I := GetLineNum( L, L1 );
  EnterCriticalSection( CritSec );
  TRY
    if L >= L1.Count then Pos := F1.Size
                     else Pos := DWORD( L1.Items[ L ] );
  FINALLY
    LeaveCriticalSection( CritSec );
  END;
  pStat1.Caption := '  Line: ' + Int2Str( I ) + '  Pos: ' + UInt2Str( Pos );
  I := GetLineNum( L, L2 );
  EnterCriticalSection( CritSec );
  TRY
    if L >= L1.Count then Pos := F1.Size
                     else Pos := DWORD( L2.Items[ L ] );
  FINALLY
    LeaveCriticalSection( CritSec );
  END;
  pStat2.Caption := '  Line: ' + Int2Str( I ) + '  Pos: ' + UInt2Str( Pos );
end;

function TForm1.GetLineNum(N: Integer; L: PList): Integer;
var Pos1, Pos: DWORD;
begin
  EnterCriticalSection( CritSec );
  TRY
    Result := N + 1;
    Pos := DWORD( L.Items[ N ] );
    while N > 0 do
    begin
      Dec( N );
      Pos1 := DWORD( L.Items[ N ] );
      if Pos = Pos1 then Dec( Result );
      Pos := Pos1;
    end;
  FINALLY
    LeaveCriticalSection( CritSec );
  END;
end;

procedure TForm1.PopupMenu1pmCopyMenu(Sender: PMenu; Item: Integer);
var LV: PControl;
    S, S1: String;
    I, N: Integer;
begin
  CASE LastLV OF
  1: LV := LV1; else LV := LV2;
  END;
  S := '';
  N := 0;
  for I := StartSelLine to StartSelLine + CountSelLines - 1 do
  begin
    if LV = LV1 then
    begin
      S1 := GetStr( I, F1, L1, Cache1 );
      if S1 = '' then
      if IsNullStr( I, L1 ) then continue;
    end
    else
    begin
      S1 := GetStr( I, F2, L2, Cache2 );
      if S1 = '' then
      if IsNullStr( I, L2 ) then continue;
    end;
    if S <> '' then
      S := S + #13#10;
    S := S + S1;
    Inc( N );
  end;
  if (N > 1) and (S[ Length( S ) ] <> #10) then
    S := S + #13#10;
  Text2Clipboard( S );
end;

procedure TForm1.PopupMenu1pmFindMenu(Sender: PMenu; Item: Integer);
begin
  if fmFind = nil then
    NewFmFind( fmFind, Applet );
  fmFind.Form.ShowModal;
  fmFind.Form.Hide;
  Applet.ProcessMessages;
  if fmFind.Form.ModalResult > 0 then
  begin
    FindPattern( fmFind.Edit1.Text );
  end;
end;

procedure TForm1.LV1MouseDown(Sender: PControl;
  var Mouse: TMouseEventData);
var L: Integer;
begin
  if Mouse.Button = mbLeft then
  begin
    if GetKeyState( VK_SHIFT ) < 0 then
    begin
      L := Sender.LVItemAtPos( Mouse.X, Mouse.Y );
      if L < 0 then Exit;
      CountLineNumbers( L );
      if StartSelLine < 0 then
        StartSelLine := 0;
      if L < StartSelLine then
        Swap( L, StartSelLine );
      CountSelLines := L - StartSelLine + 1;
      Lv1.Invalidate;
      Lv2.Invalidate;
    end
      else
    begin
      L := Sender.LVItemAtPos( Mouse.X, Mouse.Y );
      if L < 0 then Exit;
      CountLineNumbers( L );
      StartSelLine := L;
      CountSelLines := 1;
      if L < Min( LV1.LVCount, LV2.LVCount ) then
      if not EqLines( L, L ) then
      begin
        while L > 0 do
        begin
          Dec( L );
          if EqLines( L, L ) then
          begin
            Inc( L );
            CurDiffLine := L;
            break;
          end;
        end;
      end;
      Lv1.Invalidate;
      Lv2.Invalidate;
    end;
    ChkSynchronizations;
  end;
end;

procedure TForm1.PopupMenu1Popup(Sender: PObj);
var L: Integer;
    P, P1, P2: TPoint;
    LV: PControl;
begin
  GetCursorPos( P );
  P1 := LV1.Screen2Client(P);
  P2 := LV2.Screen2Client(P);
  if PointInRect( P1, LV1.ClientRect ) then
  begin
    LV := LV1;
    L := LV1.LVItemAtPos( P1.X, P1.Y );
  end
  else
  if PointInRect( P2, LV2.ClientRect ) then
  begin
    LV := LV2;
    L := LV2.LVItemAtPos( P2.X, P2.Y );
  end
  else
  begin
    LV := LV1;
    L := LV1.LVItemAtPos( P1.X, P1.Y );
  end;
  if L < 0 then
    PopupMenu1.ItemEnabled[ pmCopy ] := FALSE
  else
  if (L >= StartSelLine) and (L < StartSelLine + CountSelLines) then
  begin
    PopupMenu1.ItemEnabled[ pmCopy ] := TRUE;
  end else PopupMenu1.ItemEnabled[ pmCopy ] := FALSE;
  PopupMenu1.ItemEnabled[ pmFind ] := LV.LVCount > 0;
  PopupMenu1.ItemEnabled[ pmNext ] := (fmFind <> nil) and (fmFind.Edit1.Text <> '');
  PopupMenu1.ItemEnabled[ pmGoStartSel ] := (StartSelLine >= 0) and (CountSelLines > 0);
  PopupMenu1.ItemEnabled[ pmGoEndSel ] := (StartSelLine >= 0) and (CountSelLines > 0);
end;

procedure TForm1.PopupMenu1pmNextMenu(Sender: PMenu; Item: Integer);
begin
  if fmFind <> nil then
  begin
    FindPattern( fmFind.Edit1.Text );
  end;
end;

procedure TForm1.FindPattern(F: String);
  procedure GoLine( I: Integer );
  begin
      StartSelLine := I;
      CountLineNumbers( I );
      CountSelLines := 1;
      Dec( I, LV1.LVPerPage div 2 );
      if I < 0 then I := 0;
      LV1.LVCurItem := -1;
      LV1.LVCurItem := I;
      LV2.LVCurItem := -1;
      LV2.LVCurItem := I;
      LV1.LVMakeVisible( I + LV1.LVPerPage - 1, FALSE );
      LV2.LVMakeVisible( I + LV2.LVPerPage - 1, FALSE );
      LV1.LVMakeVisible( I, FALSE );
      LV2.LVMakeVisible( I, FALSE );
      LV1.Invalidate;
      LV2.Invalidate;
      ChkSynchronizations;
  end;
var I: Integer;
    S: String;
begin
  if not fmFind.ckCase.Checked then
    F := AnsiUpperCase( F );
  for I := StartSelLine + 1 to Min( LV1.LVCount, LV2.LVCount )-1 do
  begin
    S := GetStr( I, F1, L1, Cache1 );
    if not fmFind.ckCase.Checked then
      S := AnsiUpperCase( S );
    if pos( F, S ) > 0 then
    begin
      GoLine( I );
      Exit;
    end;
    S := GetStr( I, F2, L2, Cache2 );
    if not fmFind.ckCase.Checked then
      S := AnsiUpperCase( S );
    if pos( F, S ) > 0 then
    begin
      GoLine( I );
      Exit;
    end;
  end;
  ShowMessage( 'Pattern not found.' )
end;

procedure TForm1.LV1Enter(Sender: PObj);
begin
  LastLV := 1;
end;

procedure TForm1.LV2Enter(Sender: PObj);
begin
  LastLV := 2;
end;

function TForm1.KOLApplet1Message(var Msg: tagMSG;
  var Rslt: Integer): Boolean;
var I: Integer;
begin
  Result := FALSE;
  if Msg.message = WM_USER_SYNC_SCROLL1 then
  begin
    DoSynchronizeScroll( LV1, TScrollerBar( Msg.wParam ), Msg.lParam );
    Result := TRUE;
  end
    else
  if Msg.message = WM_USER_SYNC_SCROLL2 then
  begin
    DoSynchronizeScroll( LV2, TScrollerBar( Msg.wParam ), Msg.lParam );
    Result := TRUE;
  end
    else
  if Msg.message = WM_MOUSEWHEEL then
  begin
    I := SmallInt( HiWord( Msg.wParam ) );
    if I > 0 then
    begin
      for I := 1 to I div 40 do
      begin
        LV1.Perform( WM_VSCROLL, SB_LINEUP, 0 );
        LV2.Perform( WM_VSCROLL, SB_LINEUP, 0 );
      end;
    end
      else
    begin
      for I := 1 to Abs( I ) div 40 do
      begin
        LV1.Perform( WM_VSCROLL, SB_LINEDOWN, 0 );
        LV2.Perform( WM_VSCROLL, SB_LINEDOWN, 0 );
      end;
    end;
    Result := TRUE;
  end;
end;

procedure TForm1.Toolbar1TBFontClick(Sender: PControl; BtnID: Integer);
var Style: TFontStyle;
begin
  if fmSelFont = nil then
    NewfmSelFont( fmSelFont, Applet );
  fmSelFont.Form.ShowModal;
  fmSelFont.Form.Hide;
  if fmSelFont.Form.ModalResult > 0 then
  begin
    Style := [ ];
    if fmSelFont.ckBold.Checked then
      Style := [ fsBold ];
    LV1.Font.FontName := fmSelFont.CBFontName.Text;
    LV1.Font.FontHeight := Str2Int( fmSelFont.edFontSize.Text );
    LV1.Font.FontStyle := Style;
    LV2.Font.FontName := fmSelFont.CBFontName.Text;
    LV2.Font.FontHeight := Str2Int( fmSelFont.edFontSize.Text );
    LV2.Font.FontStyle := Style;
    Colors[ caEqText ] := fmSelFont.pEqNormalFont.Font.Color;
    Colors[ caEqBack ] := fmSelFont.pEqNormalBack.Color;
    Colors[ caEqSelText ] := fmSelFont.pEqSelFont.Font.Color;
    Colors[ caEqSelBack ] := fmSelFont.pEqSelBack.Color;
    Colors[ caDiffText ] := fmSelFont.pDiffNormalFont.Font.Color;
    Colors[ caDiffBack ] := fmSelFont.pDiffNormalBack.Color;
    Colors[ caDiffSelText ] := fmSelFont.pDiffSelfont.Font.Color;
    Colors[ caDiffSelBack ] := fmSelFont.pDiffSelBack.Color;
    Colors[ caNone ] := fmSelFont.pNoneNormalBack.Color;
    Colors[ caNoneSel ] := fmSelFont.pNoneSelBack.Color;
    AdjustHorzScrolls;
  end;
end;

function TForm1.IsNullStr(N: Integer; L: PList): Boolean;
begin
  EnterCriticalSection( CritSec );
  TRY
    Result := TRUE;
    if N >= L.Count-1 then Exit;
    Result := DWORD( L.Items[ N+1 ] ) - DWORD( L.Items[ N ] ) = 0;
  FINALLY
    LeaveCriticalSection( CritSec );
  END;
end;

procedure TForm1.PopupMenu1N2Menu(Sender: PMenu; Item: Integer);
begin
  Toolbar1TBPrevClick( nil, 0 );
end;

procedure TForm1.PopupMenu1N3Menu(Sender: PMenu; Item: Integer);
begin
  Toolbar1TBNextClick( nil, 0 );
end;

procedure TForm1.AdjustHorzScrolls;
var W1, W2, W, I: Integer;
    S1, S2: String;
begin
  if TstBmp = nil then
    TstBmp := NewBitmap( 1, 1 );
  TstBmp.Canvas.Font.Assign( LV1.Font );
  W1 := LV1.ClientWidth;
  W2 := LV2.ClientWidth;
  for I := LV1.LVTopItem to Min( LV1.LVCount-1, LV1.LVTopItem + LV1.LVPerPage ) do
  begin
    S1 := GetStr( I, F1, L1, Cache1 );
    W := TstBmp.Canvas.TextWidth( S1 ) + 4;
    if W > W1 then W1 := W;
    S2 := GetStr( I, F2, L2, Cache2 );
    W := TstBmp.Canvas.TextWidth( S2 ) + 4;
    if W > W2 then W2 := W;
  end;
  LV1.LVColWidth[ 0 ] := W1;
  LV2.LVColWidth[ 0 ] := W2;
end;

procedure TForm1.ChkSynchronizations;
var S1, S2: String;
begin
  if (StartSelLine < 0) or (CountSelLines <= 1) then
  begin
    Toolbar1.TBButtonEnabled[ TBSyncLR ] := FALSE;
    Toolbar1.TBButtonEnabled[ TBSyncRL ] := FALSE;
    Exit;
  end;

  S1 := GetStr( StartSelLine, F1, L1, Cache1 );
  S2 := GetStr( StartSelLine + CountSelLines - 1, F2, L2, Cache2 );
  if Eq( S1, S2 ) then
  Toolbar1.TBButtonEnabled[ TBSyncLR ] := TRUE
  else
  Toolbar1.TBButtonEnabled[ TBSyncLR ] := FALSE;

  S1 := GetStr( StartSelLine + CountSelLines - 1, F1, L1, Cache1 );
  S2 := GetStr( StartSelLine, F2, L2, Cache2 );
  if Eq( S1, S2 ) then
  Toolbar1.TBButtonEnabled[ TBSyncRL ] := TRUE
  else
  Toolbar1.TBButtonEnabled[ TBSyncRL ] := FALSE;
end;

procedure TForm1.PopupMenu1pmGoStartSelMenu(Sender: PMenu; Item: Integer);
var I, J: Integer;
begin
  I := StartSelLine + LV1.LVPerPage div 2 - 1;
  if I >= LV1.LVCount then I := LV1.LVCount - 1;
  if I >= LV2.LVCount then I := LV2.LVCount - 1;
  J := StartSelLine - LV1.LVPerPage div 2 + 1;
  if J < 0 then J := 0;
  LV1.LVCurItem := -1;
  LV1.LVCurItem := J;
  LV2.LVCurItem := -1;
  LV2.LVCurItem := J;
  LV1.LVMakeVisible( I, FALSE );
  LV2.LVMakeVisible( I, FALSE );
  LV1.LVMakeVisible( J, FALSE );
  LV2.LVMakeVisible( J, FALSE );
end;

procedure TForm1.PopupMenu1pmGoEndSelMenu(Sender: PMenu; Item: Integer);
var I, J: Integer;
begin
  I := StartSelLine + CountSelLines - 1 + LV1.LVPerPage div 2 - 1;
  if I >= LV1.LVCount then I := LV1.LVCount - 1;
  if I >= LV2.LVCount then I := LV2.LVCount - 1;
  J := StartSelLine + CountSelLines - 1 - LV1.LVPerPage + 1;
  if J < 0 then J := 0;
  LV1.LVCurItem := -1;
  LV1.LVCurItem := J;
  LV2.LVCurItem := -1;
  LV2.LVCurItem := J;
  LV1.LVMakeVisible( I, FALSE );
  LV2.LVMakeVisible( I, FALSE );
end;

procedure TForm1.Toolbar1TBSyncLRClick(Sender: PControl; BtnID: Integer);
begin
  ContLeftFrom := StartSelLine;
  ContRightFrom := StartSelLine + CountSelLines - 1;
  WantReSynchronize := TRUE;
end;

procedure TForm1.Toolbar1TBSyncRLClick(Sender: PControl; BtnID: Integer);
begin
  ContRightFrom := StartSelLine;
  ContLeftFrom := StartSelLine + CountSelLines - 1;
  WantReSynchronize := TRUE;
end;

function TForm1.CompareLinesFast(S1, S2: PChar): Boolean;
var C1, C2: Char;
begin
  Result := FALSE;
  while (S1^ <> #0) and (S2^ <> #0) do
  begin
    C1 := S1^;
    C2 := S2^;
    if (C1 in [ #13, #10 ]) and (C2 in [ #13, #10 ]) then
    begin
      Result := TRUE;
      Exit;
    end;
    if not Compare_Tabs and (C1 = #9) then C1 := ' ';
    if not Compare_Tabs and (C2 = #9) then C2 := ' ';
    if not Compare_Spaces and ((C1 = ' ') or (C2 = ' ')) then
    begin
      if (C1 <> ' ') or (C2 <> ' ') then Exit;
      while C1 = ' ' do
      begin
        Inc( S1 );
        C1 := S1^;
        if not Compare_Tabs and (C1 = #9) then C1 := ' ';
      end;
      while C2 = ' ' do
      begin
        Inc( S2 );
        C2 := S2^;
        if not Compare_Tabs and (C2 = #9) then C2 := ' ';
      end;
      continue;
    end;
    if not Compare_Case then
    begin
      C1 := UpCase[ C1 ];
      C2 := UpCase[ C2 ];
    end;
    if C1 <> C2 then Exit;
    Inc( S1 );
    Inc( S2 );
  end;
  Result := TRUE;
end;

procedure TForm1.InitUpCase;
var S: String;
    I: Integer;
begin
  S := '';
  for I := 1 to 255 do
    S := S + Char( I );
  S := AnsiUpperCase( S );
  UpCase[ #0 ] := #0;
  for I := 1 to 255 do
    UpCase[ Char( I ) ] := S[ I ];
end;

procedure TForm1.LV1EraseBkgnd(Sender: PControl; DC: HDC);
var i: Integer;
    CR, R: TRect;
begin
  i := Sender.LVTopItem;
  CR := Sender.ClientRect;
  if i < 0 then
    Sender.Canvas.FillRect( CR )
  else
  begin
    R := Sender.LVItemRect( i, lvipBounds );
    Sender.Canvas.FillRect( MakeRect( R.Left, 0, CR.Right, R.Top ) );
    i := i + Sender.LVPerPage;
    if i >= Sender.LVCount then
      i := Sender.LVCount - 1;
    R := Sender.LVItemRect( i, lvipBounds );
    if R.Bottom < CR.Bottom then
    Sender.Canvas.FillRect( MakeRect( R.Left, R.Bottom, R.Right, CR.Bottom ) );
  end;
end;

procedure TForm1.LV1LVStateChange(Sender: PControl; IdxFrom,
  IdxTo: Integer; OldState, NewState: Cardinal);
begin
  if NewState and lvis_Selected <> 0 then
  begin
    if Sender = LV1 then
      LV2.LVCurItem := IdxFrom
    else
      LV1.LVCurItem := IdxFrom;
  end;
end;

end.




