{ KOL MCK } // Do not remove this line!
{$DEFINE KOL_MCK}
unit SelFontUnit;

interface

{$IFDEF KOL_MCK}
uses Windows, Messages, ShellAPI, KOL {$IFNDEF KOL_MCK}, mirror, Classes,
  Controls, mckCtrls, Graphics, mckObjs {$ENDIF};
{$ELSE}
{$I uses.inc}
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs;
{$ENDIF}

type
  {$IFDEF KOL_MCK}
  {$I MCKfakeClasses.inc}
  {$IFDEF KOLCLASSES} TfmSelFont = class; PfmSelFont = TfmSelFont; {$ELSE OBJECTS} PfmSelFont = ^TfmSelFont; {$ENDIF CLASSES/OBJECTS}
  {$IFDEF KOLCLASSES}{$I TfmSelFont.inc}{$ELSE} TfmSelFont = object(TObj) {$ENDIF}
    Form: PControl;
  {$ELSE not_KOL_MCK}
  TfmSelFont = class(TForm)
  {$ENDIF KOL_MCK}
    KOLForm1: TKOLForm;
    CBFontName: TKOLComboBox;
    edFontSize: TKOLEditBox;
    Button1: TKOLButton;
    Button2: TKOLButton;
    Button3: TKOLButton;
    Button4: TKOLButton;
    ckBold: TKOLCheckBox;
    Label1: TKOLLabel;
    pEqNormalFont: TKOLPanel;
    pEqNormalBack: TKOLPanel;
    Label2: TKOLLabel;
    pDiffNormalFont: TKOLPanel;
    pDiffNormalBack: TKOLPanel;
    Label3: TKOLLabel;
    pEqSelFont: TKOLPanel;
    pEqSelBack: TKOLPanel;
    pDiffSelFont: TKOLPanel;
    pDiffSelBack: TKOLPanel;
    Label4: TKOLLabel;
    pNoneNormalBack: TKOLPanel;
    pNoneSelBack: TKOLPanel;
    Label5: TKOLLabel;
    CD: TKOLColorDialog;
    Button5: TKOLButton;
    procedure KOLForm1Show(Sender: PObj);
    procedure Button3Click(Sender: PObj);
    procedure Button4Click(Sender: PObj);
    procedure Button1Click(Sender: PObj);
    procedure Button2Click(Sender: PObj);
    procedure ckBoldClick(Sender: PObj);
    procedure pEqNormalFontClick(Sender: PObj);
    procedure Button5Click(Sender: PObj);
    procedure CBFontNameChange(Sender: PObj);
    procedure edFontSizeChange(Sender: PObj);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  fmSelFont {$IFDEF KOL_MCK} : PfmSelFont {$ELSE} : TfmSelFont {$ENDIF} ;

{$IFDEF KOL_MCK}
procedure NewfmSelFont( var Result: PfmSelFont; AParent: PControl );
{$ENDIF}

implementation

uses MainLinesDiff;

function EnumFonts(
  LFData: PENUMLOGFONTEX;    // logical-font data
  PFData: PNEWTEXTMETRICEX;  // physical-font data
  FontType: DWORD;           // type of font
  lParam: LPARAM             // application-defined data
): Integer;
stdcall;
var L: PStrList;
begin
  L := Pointer( lParam );
  if L.IndexOf( LFData.elfFullName ) < 0 then
    L.Add( LFData.elfFullName );
  Result := 1; // non-zero to continue enumeration
end;


{$IFNDEF KOL_MCK} {$R *.DFM} {$ENDIF}

{$IFDEF KOL_MCK}
{$I SelFontUnit_1.inc}
{$ENDIF}

procedure TfmSelFont.KOLForm1Show(Sender: PObj);
var LF: TLogFont;
    DC0: HDC;
    L: PStrList;
    I, J: Integer;
begin
  ckBold.Checked := fsBold in Form1.LV1.Font.FontStyle;
  ckBoldClick( nil );
  if Form1.LV1.Font.FontHeight > 0 then
    edFontSize.Text := Int2Str( Form1.LV1.Font.FontHeight );
  pEqNormalFont.Font.Color := Form1.Colors[ caEqText ];
  pEqNormalBack.Font.Color := Form1.Colors[ caEqText ];
  pEqNormalFont.Color := Form1.Colors[ caEqBack ];
  pEqNormalBack.Color := Form1.Colors[ caEqBack ];
  pEqSelFont.Font.Color := Form1.Colors[ caEqSelText ];
  pEqSelBack.Font.Color := Form1.Colors[ caEqSelText ];
  pEqSelFont.Color := Form1.Colors[ caEqSelBack ];
  pEqSelBack.Color := Form1.Colors[ caEqSelBack ];
  pDiffNormalFont.Font.Color := Form1.Colors[ caDiffText ];
  pDiffNormalBack.Font.Color := Form1.Colors[ caDiffText ];
  pDiffNormalFont.Color := Form1.Colors[ caDiffBack ];
  pDiffNormalBack.Color := Form1.Colors[ caDiffBack ];
  pDiffSelFont.Font.Color := Form1.Colors[ caDiffSelText ];
  pDiffSelBack.Font.Color := Form1.Colors[ caDiffSelText ];
  pDiffSelFont.Color := Form1.Colors[ caDiffSelBack ];
  pDiffSelBack.Color := Form1.Colors[ caDiffSelBack ];
  pNoneNormalBack.Color := Form1.Colors[ caNone ];
  pNoneSelBack.Color := Form1.Colors[ caNoneSel ];

  FillChar( LF, Sizeof( LF ), 0 );
  LF.lfCharSet := DEFAULT_CHARSET;
  DC0 := GetDC( 0 );
  L := NewStrList;
  EnumFontFamiliesEx( DC0, LF, @EnumFonts, DWORD( L ), 0 );
  ReleaseDC( 0, DC0 );
  CBFontName.Clear;
  for I := 0 to L.Count-1 do
  begin
    J := CBFontName.Add( L.Items[ I ] );
    if StrEq( Form1.LV1.Font.FontName, L.Items[ I ] ) then
      CBFontName.CurIndex := J;
  end;
  L.Free;
end;

procedure TfmSelFont.Button3Click(Sender: PObj);
begin
  Form.ModalResult := 1;
end;

procedure TfmSelFont.Button4Click(Sender: PObj);
begin
  Form.ModalResult := -1;
end;

procedure TfmSelFont.Button1Click(Sender: PObj);
begin
  if Str2Int( edFontSize.Text ) > 6 then
    edFontSize.Text := Int2Str( Str2Int( edFontSize.Text ) - 1 );
end;

procedure TfmSelFont.Button2Click(Sender: PObj);
begin
  edFontSize.Text := Int2Str( Str2Int( edFontSize.Text ) + 1 );
end;

procedure TfmSelFont.ckBoldClick(Sender: PObj);
var Style: TFontStyle;
begin
  Style := [ ];
  if ckBold.Checked then
    Style := [ fsBold ];
  pEqNormalFont.Font.FontStyle := Style;
  pEqNormalBack.Font.FontStyle := Style;
  pEqSelFont   .Font.FontStyle := Style;
  pEqSelBack   .Font.FontStyle := Style;
  pDiffNormalFont.Font.FontStyle := Style;
  pDiffNormalBack.Font.FontStyle := Style;
  pDiffSelFont   .Font.FontStyle := Style;
  pDiffSelBack   .Font.FontStyle := Style;
  pNoneNormalBack.Font.FontStyle := Style;
  pNoneSelBack   .Font.FontStyle := Style;
end;

procedure TfmSelFont.pEqNormalFontClick(Sender: PObj);
begin
  if CD.Execute then
  begin
    CASE Sender.Tag OF
    1: begin
         pEqNormalFont.Font.Color := CD.Color;
         pEqNormalBack.Font.Color := CD.Color;
       end;
    2: begin
         pEqNormalFont.Color := CD.Color;
         pEqNormalBack.Color := CD.Color;
       end;
    3: begin
         pEqSelFont.Font.Color := CD.Color;
         pEqSelBack.Font.Color := CD.Color;
       end;
    4: begin
         pEqSelFont.Color := CD.Color;
         pEqSelBack.Color := CD.Color;
       end;
    5: begin
         pDiffNormalFont.Font.Color := CD.Color;
         pDiffNormalBack.Font.Color := CD.Color;
       end;
    6: begin
         pDiffNormalFont.Color := CD.Color;
         pDiffNormalBack.Color := CD.Color;
       end;
    7: begin
         pDiffSelFont.Font.Color := CD.Color;
         pDiffSelBack.Font.Color := CD.Color;
       end;
    8: begin
         pDiffSelFont.Color := CD.Color;
         pDiffSelBack.Color := CD.Color;
       end;
    9: pNoneNormalBack.Color := CD.Color;
    10:pNoneSelBack.Color := CD.Color;
    END;
  end;
end;

procedure TfmSelFont.Button5Click(Sender: PObj);
begin
  pEqNormalFont.Font.Color := clWindowText;
  pEqNormalBack.Font.Color := clWindowText;
  pEqNormalFont.Color := clWindow;
  pEqNormalBack.Color := clWindow;

  pEqSelFont.Font.Color := clHighlightText;
  pEqSelBack.Font.Color := clHighlightText;
  pEqSelFont.Color := clHighlight;
  pEqSelBack.Color := clHighlight;

  pDiffNormalFont.Font.Color := clRed;
  pDiffNormalBack.Font.Color := clRed;
  pDiffNormalFont.Color := clWindow;
  pDiffNormalBack.Color := clWindow;

  pDiffSelFont.Font.Color := clYellow;
  pDiffSelBack.Font.Color := clYellow;
  pDiffSelFont.Color := clHighlight;
  pDiffSelBack.Color := clHighlight;

  pNoneNormalBack.Color := clYellow;
  pNoneSelBack.Color := clOlive;
end;

procedure TfmSelFont.CBFontNameChange(Sender: PObj);
begin
  pEqNormalFont.Font.FontName := CBFontName.Text;
  pEqNormalBack.Font.FontName := CBFontName.Text;
  pEqSelFont   .Font.FontName := CBFontName.Text;
  pEqSelBack   .Font.FontName := CBFontName.Text;
  pDiffNormalFont.Font.FontName := CBFontName.Text;
  pDiffNormalBack.Font.FontName := CBFontName.Text;
  pDiffSelFont   .Font.FontName := CBFontName.Text;
  pDiffSelBack   .Font.FontName := CBFontName.Text;
end;

procedure TfmSelFont.edFontSizeChange(Sender: PObj);
var H: Integer;
begin
  H := Str2Int( edFontSize.Text );
  pEqNormalFont.Font.FontHeight := H;
  pEqNormalBack.Font.FontHeight := H;
  pEqSelFont   .Font.FontHeight := H;
  pEqSelBack   .Font.FontHeight := H;
  pDiffNormalFont.Font.FontHeight := H;
  pDiffNormalBack.Font.FontHeight := H;
  pDiffSelFont   .Font.FontHeight := H;
  pDiffSelBack   .Font.FontHeight := H;
end;

end.



